#!/bin/bash

cduDiagFolder=/tmp/__cduDiag

#
#
#
echo "Make RTDiag folder in /tmp"
rm -rf ${cduDiagFolder}
mkdir ${cduDiagFolder}
mkdir ${cduDiagFolder}/var_logs

if [ -d ${cduDiagFolder} ]; then
	echo "Make CDU Diag folder in /tmp ... OK"
else
	echo "Make CDU Diag folder in /tmp ... Fail"
	exit 0
fi

#
#
#
echo "Dump AppleRAID Info"
diskutil checkRAID > ${cduDiagFolder}/__AppleRAIDInfo

#
#
#
echo "Dump kextstat"
kextstat > ${cduDiagFolder}/___dmp_kextstat

#
#
#
echo "Dump driver logs after 10.12 ..."
log show | grep CalDigit > ${cduDiagFolder}/var_logs/CalDigitRAID.log

#
#
#
echo "Dump system logs after 10.12 ..."
# log show > ${cduDiagFolder}/var_logs/all.log
log collect --output ${cduDiagFolder}/var_logs

#
#
#
echo "zip /var/log/system"
echo "zip /var/log/install"
cp -rf /var/log/system.log ${cduDiagFolder}/var_logs
cp -rf /var/log/install.log ${cduDiagFolder}/var_logs
cp -rf /var/log/system.log.* ${cduDiagFolder}/var_logs
tar -czf ${cduDiagFolder}/__var_log.tar.gz ${cduDiagFolder}/var_logs
rm -rf ${cduDiagFolder}/var_logs

#
#
#
echo "Dump system_profiler. This procedure will take miniutes ..."
system_profiler -detailLevel full > ${cduDiagFolder}/__system_profiler

#
#
#
echo "Dump __TEMP_XXX"
cp -rf /tmp/__TEMP_* ${cduDiagFolder}/

#
# Do any actions in above sections
#
echo "Put cduDiagFolder on desktop"
tar -czf ~/Desktop/CRI_CDU_diag.tar.gz ${cduDiagFolder}

#
#
#
if [ -f ~/Desktop/CRI_CDU_diag.tar.gz ]; then
	echo "CDU diag done."
else
	echo "CDU diag error - Can't find CRI_CDU_diag"
fi
